/*****************************************************************************\
 * ManualDialog.java
 *
 * $Author: blais $
 * $Date: 1997/11/11 23:17:49 $
 *
 * Desc:        Manual dialog for quadrangulation application.
 *
 *****************************************************************************/
/*****************************************************************************\
 * Copyright (C) 1996, Martin Blais.
 * All Rights Reserved.
 * 
 * This is unpublished proprietary source code of Martin Blais;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Martin Blais.
 *****************************************************************************/

import java.awt.* ;
import java.io.*;
import java.net.*;
import java.lang.SecurityException ;

///////////////////////////////////////////////////////////////////////////////
//
// class ManualDialog
//
///////////////////////////////////////////////////////////////////////////////

public class ManualDialog extends Frame
{
    ///////////////////////////////////////////////////////////////////////////
    // Constants
    
    public final static int xsize = 540 ;
    public final static int ysize = 400 ;
    
    public String m_HelpText ;

    ///////////////////////////////////////////////////////////////////////////
    // Data members
    
    Button		m_butClose ;
    TextArea	 	m_TextArea ;    
    
    ///////////////////////////////////////////////////////////////////////////
    // ManualDialog.ManualDialog
    //
    public ManualDialog( Frame in_Parent, boolean fModal, URL codeBase )
    {
//        super( in_Parent, fModal ) ;
        setTitle( "Manual" ) ;
        resize( xsize, ysize ) ;
        setResizable( false ) ;

	// Read the help file
	try 
	    {
// 		File inputFile = new File("Help.txt");
// 		FileInputStream fis = new FileInputStream(inputFile);
		URL url ;
		if ( codeBase != null )
		{
		    url = new URL( codeBase, "Help.txt" ) ;
		}
		else
		{
		    url = new URL( "Help.txt" ) ;
		}

		URLConnection con = url.openConnection() ;
		InputStream fis = con.getInputStream() ;
		byte[] buf = new byte[ con.getContentLength() +1 ] ;
		System.out.println( con.getContentLength() ) ;

		fis.read( buf ) ;

		fis.close();

		m_HelpText = new String( buf, 0 ) ;
	    } 
	catch (FileNotFoundException e) 
	    {
		System.err.println("FileStreamsTest: " + e);
	    } 
	catch (IOException e) 
	    {
		System.err.println("FileStreamsTest: " + e);
	    }
	catch ( SecurityException e ) 
	    {
		m_HelpText = "Can't open help file: SecurityException" ;
	    }
// 	catch ( MalformedURLException e )
// 	    {
// 		m_HelpText = "Malformed URL Exception." ;
// 	    }

        BuildUI() ;
    }


    ///////////////////////////////////////////////////////////////////////
    // ManualDialog.BuildUI
    //
    public void BuildUI()
    {
        ///////////////////////////////////////////////////////////////////////
        // Build work area
        setLayout( new BorderLayout() ) ;

        // Button panel
        m_butClose = new Button( "Close" ) ;
        add( "South", m_butClose ) ;

        // TextArea
        m_TextArea = new TextArea( m_HelpText ) ;
        add( "Center", m_TextArea ) ;
	m_TextArea.setEditable( false ) ;

        pack() ;
    }


    ///////////////////////////////////////////////////////////////////////////
    // ManualDialog.handleEvent
    // 
    public boolean handleEvent( Event in_Event )
    {
        // Handle window_destroy events
        if ( in_Event.id == Event.WINDOW_DESTROY )
        {
            dispose() ;
	    return true ;
        }
	else
	{
	    return super.handleEvent( in_Event ) ;
	}
    }

    ///////////////////////////////////////////////////////////////////////////
    // ManualDIalog.action
    //
    public boolean action( Event in_Event, Object in_Object )
    {
        boolean fHandled = true ;

        // Handle Ok Button
	if ( in_Object.equals("Close") )
	{
	    dispose() ;
	}
        return fHandled ;
    }
}

